<template>
  <JMenu
    v-model="menuModel"
    open-on-hover
    :close-on-click="false"
  >
    <template #activator="menuProps">
      <div @click.stop.prevent>
        <UserAvatar
          v-if="hideAvatar === false"
          v-bind="menuProps"
          :tabindex="tabindex"
          :avatar="user.avatar"
          :avatar-size="avatarSize"
          :hide-status="hideStatus"
          class="activator"
        />
      </div>
    </template>

    <slot />
  </JMenu>
</template>

<script setup lang="ts">
import { PropType, ref } from 'vue';
import { JMenu } from '@new-jira-clone/ui/src/components';
import { UserAvatar } from '@/entities/User';
import { IUser } from '@/shared';

defineProps({
  user: {
    type: Object as PropType<IUser>,
    required: true,
  },
  avatarSize: {
    type: String,
    defaut: 'm',
  },
  hideStatus: {
    type: Boolean,
    default: false,
  },
  hideAvatar: {
    type: Boolean,
    default: false,
  },
  tabindex: {
    type: [Number, String],
    default: -1,
  },
});

const menuModel = ref(false);
</script>

<style scoped lang="scss">
.activator {
  &:focus-visible {
    outline-offset: 2px;
    outline: var(--j-focus-outline);
  }
}
</style>
